---
variables:
  TEMPLATE: Covid-19-Bubble-spread-02-1
stages:
  - build
  - publish

build-gif-mr:
  image:
    name: registry.gitlab.com/msutter/gimp-gif-translate:latest
  
  stage: build

  script:
    - echo ${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}
    - /translate.sh -f templates/${TEMPLATE}.xcf -p /translate-gif.py -l ${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}

  only:
    refs:
      - merge_requests
    changes:
      - languages/**/text.yaml

  artifacts:
    paths:
      - releases/${TEMPLATE}-${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}.gif

build-gif-master:
  image:
    name: registry.gitlab.com/msutter/gimp-gif-translate:latest
  
  stage: build

  script:
    - echo ${CI_MERGE_REQUEST_SOURCE_BRANCH_NAME}
    - /translate.sh -f templates/${TEMPLATE}.xcf -p /translate-gif.py -a

  only:
    refs:
      - master
    changes:
      - languages/**/text.yaml
      - templates/*

  artifacts:
    paths:
      - releases/*.gif

.create-release-message: &create-release-message |
  echo '## Available translations' > release_message.txt
  echo >> release_message.txt
  for release in $(ls releases/*.gif | sort);do
      filename=$(basename $release)
      lg_code=$(echo ${filename} | sed "s/${TEMPLATE}-\(.*\)\.gif/\1/")
      echo $lg_code
      iso_639=$(echo ${lg_code} | awk -F'-' '{print $1}')
      iso_3166=$(echo ${lg_code} | awk -F'-' '{print $2}')
      echo $iso_639
      echo $iso_3166

      iso_639_valid=false
      iso_3166_valid=false

      json_countries="$(curl https://restcountries.eu/rest/v2/lang/${iso_639})"
      iso_639_valid=$(echo $json_countries | jq -r '. |type=="array"')
      echo "iso_639_valid: $iso_639_valid"

      if ! $iso_639_valid
      then
          echo "Warning: iso code 639 '$iso_639' not found in restcountries.eu"
          lg_name="$iso_639 (unkown at restcountries.eu)"
      else
          iso_3166_valid=true
          lg_name=$(echo $json_countries | jq -r --arg iso_639 "$iso_639" '.[0].languages[] | select(.iso639_1==$iso_639).name')
      fi

      if [ ! -z "$iso_3166" ]
      then
          json_countries="[$(curl https://restcountries.eu/rest/v2/alpha/${iso_3166})]"
          iso_3166_valid=$(echo $json_countries | jq -r '.[0]| has("name")')
      fi
      echo "iso_3166_valid: $iso_3166_valid"

      if $iso_3166_valid
      then
          flags=$(echo $json_countries | jq -r '.[].flag')
      else
          flags=''
      fi

      echo $lg_name
      echo $flags

      # write message
      cat << EOF >> release_message.txt
  ---
  #### ${lg_name}

  EOF
      if [ ! -z "$flags" ]
      then
          for flag_link in ${flags}
          do
              echo "<img src="${flag_link}" alt="drawing" width="30"/>" >> release_message.txt
          done
      fi
      cat << EOF >> release_message.txt

  [${filename}]
  <details><summary>preview</summary>

  ![${filename}]
  
  </details>

  EOF
  done
  export release_message=$(cat release_message.txt)
  echo "${release_message}"
  rm release_message.txt

.install-tools: &install-tools |
  apk update
  apk add curl jq git
  
publish:
  image: python:3.7-alpine
  stage: publish
  only:
    - tags
  script:
    - *install-tools
    - 'curl --location --output gifs.zip "https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/jobs/artifacts/master/download?job=build-gif-master&job_token=$CI_JOB_TOKEN"'
    - unzip gifs.zip
    - pip3 install git+https://gitlab.com/msutter/gitlab-release.git@image-link
    - *create-release-message
    - gitlab-release --link-ref --description "${release_message}" releases/*.gif

